
//`#start header` -- edit after this line, do not edit this line
// ========================================
//
// Copyright YOUR COMPANY, THE YEAR
// All Rights Reserved
// UNPUBLISHED, LICENSED SOFTWARE.
//
// CONFIDENTIAL AND PROPRIETARY INFORMATION
// WHICH IS THE PROPERTY OF your company.
//
// ========================================
`include "cypress.v"
//`#end` -- edit above this line, do not edit this line
// Generated on 03/14/2017 at 16:05
// Component: ControlReg32_v0_0
module ControlReg32_v0_0 (
	output  ctrl, //variable width output
	input   clk,
	input   rst
);

//`#start body` -- edit after this line, do not edit this line

    // Width parameters //

    parameter [7:0] bus_width = 8'd8; // [4:0} is sufficient - no effect
    localparam  hi = bus_width - 1;     // high index        

    wire [hi:0] ctrl;
    
    localparam CTRL_DIRECT  = 2'b00;  // direct API call
    localparam CTRL_SYNC    = 2'b01;  // Sync
    localparam CTRL_PULSE   = 2'd10;  // Pulse
    parameter control_mode = CTRL_DIRECT;
    
   
    parameter reset = 1'b0;
    
    parameter [31:0] value = 32'd0;
    localparam [7:0] byte0 =  value      & 8'hFF;
    localparam [7:0] byte1 = (value>> 8) & 8'hFF;
    localparam [7:0] byte2 = (value>>16) & 8'hFF;
    localparam [7:0] byte3 = (value>>24) & 8'hFF;
    
    
    wire [31:0]  control_cr;                    // Control Register output
    assign ctrl = control_cr;


//==============================================================================
//          API control registers to set phase increment and shift
//
//  tune_word = {ControlPhaseC, ControlPhaseB, ControlPhaseA}
//  where ControlPhaseA, ControlPhaseB, ControlPhaseC - are Lo, Me, Hi bits
//
//  options: (i) direct API update or (ii) buffered with hardware strobe
//==============================================================================
   
    localparam mode = (control_mode==CTRL_SYNC)? 8'h00 : 8'hFF; // sync (0) or pulse (1) mode

    generate                                
    if (control_mode==1'b0) begin: sControl                                     // direct API update
 
            cy_psoc3_control #(.cy_init_value (byte0), .cy_force_order(`TRUE))  // default mode
            ControlByte0(
                .control(control_cr[7:0]));                                     // output bits [07:00]

            cy_psoc3_control #(.cy_init_value (byte1), .cy_force_order(`TRUE))  // default mode
            ControlByte1(
                .control(control_cr[15:8]));                                    // output bits [15:08]
    
            cy_psoc3_control #(.cy_init_value (byte2), .cy_force_order(`TRUE))  // default mode
            ControlByte2(
                .control(control_cr[23:16]));                                   // output bits [23:16]
               
            cy_psoc3_control #(.cy_init_value (byte3), .cy_force_order(`TRUE))  // default mode
            ControlByte3(
                .control(control_cr[31:24]));                                   // output bits [31:24] 
        
    end
    else begin: sControl                                                        // sync or pulse 

            cy_psoc3_control #(.cy_init_value (byte0), .cy_force_order(`TRUE), .cy_ctrl_mode_1(mode), .cy_ctrl_mode_0(8'hFF)) //Sync,pulse mode
            ControlByte0(
                .control(control_cr[7:0]),                                      // output bits [07:00]
                .reset(rst),                                                    // reset from interconnec
                .clock(clk)            );                                       // hw load 
            
            cy_psoc3_control #(.cy_init_value (byte1), .cy_force_order(`TRUE), .cy_ctrl_mode_1(mode), .cy_ctrl_mode_0(8'hFF)) //Sync,pulse mode
            ControlByte1(
                .control(control_cr[15:8]),                                     // output bits [15:08]
                .reset(rst),                                                    // reset from interconnec
                .clock(clk)             );                                      // hw load 
    
            cy_psoc3_control #(.cy_init_value (byte2), .cy_force_order(`TRUE), .cy_ctrl_mode_1(mode), .cy_ctrl_mode_0(8'hFF)) //Sync,pulse mode
            ControlByte2(
                .control(control_cr[23:16]),                                    // output bits [23:16]
                .reset(rst),                                                    // reset from interconnec
                .clock(clk)              );                                     // hw load
               
            cy_psoc3_control #(.cy_init_value (byte3), .cy_force_order(`TRUE), .cy_ctrl_mode_1(mode), .cy_ctrl_mode_0(8'hFF)) //Sync,pulse mode
            ControlByte3(
                .control(control_cr[31:24]),                                    // output bits [32:24]
                .reset(rst),                                                    // reset from interconnec
                .clock(clk)        );                                           // hw load

    end
    endgenerate
   

//`#end` -- edit above this line, do not edit this line
endmodule
//`#start footer` -- edit after this line, do not edit this line
//`#end` -- edit above this line, do not edit this line
